
' Eieruhr_1A
' 15.01.2012
' Funktion
' Mit Timer 1 wird ein Sekundentakt erzeugt

' ber zwei Taster Minus und Plus wird die Zeit in Minuten eingegeben und in
' Variable "Zeitvorgabe" gespeichert:
' Mit Timer 1 wird alle Sekunde ein Interrupt ausgelst und damit in eine
' Routine gesprungen in der die Sekunden von der Vorgabezeit subtrahiert werden
' sobald Start Taster gedrckt wurde






'--------------------- Allgemeine Prozessor Konfiguration ----------------------
$regfile "m8def.dat"     'Definiert den Atmega als Atmega8
$crystal = 1000000       'Gibt die Quarzfrequenz an in Herz
$hwstack = 32            'Default use 32 Hardware reservierte Speicher
$swstack = 10            'Default Software resvierung Speicher


'------------------------------------------------------------------------------
Ddrc = &B11111111        ' Gesamter Port C als Ausgang setzen
Ddrb = &B11111111        ' Port B.7 als Ausgang setzen
Ddrd = &B11100011        ' Port D5, D6, D7 als Ausgang setzen
Portd = &B00011100       ' Pull Up fr Port D2 und D3 und d4setzen

'------------------------ Variable --------------------------------------------
Dim Zeitvorgabe As Word
Dim Zeit As Word         ' Variable fr Sekundentakt#
On Timer1 Timer_eins
'----------------  Timer 1 dekjlarieren fr Sekundentakt ----------------------

Tccr1a = &B00000000
Tccr1b = &B00000011
Timsk = &B00000100       ' Interrupt fr Timerberlauf einschalten
Sreg = &B10000000        ' Interrupt Freigeben
Timer1 = 49911           ' Vorgabe

'------------------------ Programm --------------------------------------------



   Sound Portb.1 , 1000 , 20


Do

If Pind.2 = 0 Then Waitms 20
If Pind.2 = 0 Then Zeitvorgabe = Zeitvorgabe -60
If Pind.2 = 0 Then Sound Portb.1 , 500 , 20

If Pind.3 = 0 Then Waitms 20
If Pind.3 = 0 Then Zeitvorgabe = Zeitvorgabe + 60
If Pind.3 = 0 Then Sound Portb.1 , 500 , 20



If Zeitvorgabe > 59 Then Portc.5 = 1 Else Portc.5 = 0
If Zeitvorgabe > 119 Then Portc.4 = 1 Else Portc.4 = 0
If Zeitvorgabe > 179 Then Portc.3 = 1 Else Portc.3 = 0
If Zeitvorgabe > 239 Then Portc.2 = 1 Else Portc.2 = 0
If Zeitvorgabe > 299 Then Portc.1 = 1 Else Portc.1 = 0
If Zeitvorgabe > 359 Then Portc.0 = 1 Else Portc.0 = 0
If Zeitvorgabe > 419 Then Portb.5 = 1 Else Portb.5 = 0
If Zeitvorgabe > 479 Then Portb.4 = 1 Else Portb.4 = 0
If Zeitvorgabe > 539 Then Portb.3 = 1 Else Portb.3 = 0
If Zeitvorgabe > 599 Then Portb.2 = 1 Else Portb.2 = 0

Zeit = Zeitvorgabe

If Pind.4 = 0 Then Exit Do
Loop

'----------------------------------------------------------------------------
Sound Portb.1 , 1000 , 20
Do
Zeitvorgabe = Zeit
If Zeitvorgabe > 1 Then Portc.5 = 1 Else Portc.5 = 0
Waitms 5
If Zeitvorgabe > 60 Then Portc.4 = 1 Else Portc.4 = 0
Waitms 5
If Zeitvorgabe > 120 Then Portc.3 = 1 Else Portc.3 = 0
Waitms 5
If Zeitvorgabe > 180 Then Portc.2 = 1 Else Portc.2 = 0
Waitms 5
If Zeitvorgabe > 240 Then Portc.1 = 1 Else Portc.1 = 0
Waitms 5
If Zeitvorgabe > 300 Then Portc.0 = 1 Else Portc.0 = 0
Waitms 5
If Zeitvorgabe > 360 Then Portb.5 = 1 Else Portb.5 = 0
Waitms 5
If Zeitvorgabe > 420 Then Portb.4 = 1 Else Portb.4 = 0
Waitms 5
If Zeitvorgabe > 480 Then Portb.3 = 1 Else Portb.3 = 0
Waitms 5
If Zeitvorgabe > 540 Then Portb.2 = 1 Else Portb.2 = 0
Waitms 50


Portc.5 = 0
Waitms 20
Portc.4 = 0
Waitms 20
Portc.3 = 0
Waitms 20
Portc.2 = 0
Waitms 20
Portc.1 = 0
Waitms 20
Portc.0 = 0
Waitms 20
Portb.5 = 0
Waitms 20
Portb.4 = 0
Waitms 20
Portb.3 = 0
Waitms 20
Portb.2 = 0



If Zeit < 1 Then Goto Alarm
Loop

'-------------------------  Timer 1 Interrupt Routine ---------------------------------------------
Timer_eins:
Timer1 = 49911
Zeit = Zeit
Decr Zeit
Return
'------------------------------- A l a r m -------------------------------------
Alarm:
Do
Waitms 20
Sound Portb.1 , 500 , 50

Sound Portb.1 , 500 , 20
Portd.7 = 1
Waitms 8
Portd.7 = 0

If Pind.4 = 0 Then Waitms 20

If Pind.4 = 0 Then Exit Do


Loop

Stop







Return



'-------------------------------------------------------------------------------